function[f] = calcEndeffektorVREP(poses,delta)
    global vrep_connection;

    vrep_connection.vrep.simxStopSimulation(vrep_connection.clientID,vrep_connection.vrep.simx_opmode_oneshot_wait);
    pause(1.0);
    currentPose = getAngles();
    vrep_connection.vrep.simxStartSimulation(vrep_connection.clientID,vrep_connection.vrep.simx_opmode_oneshot_wait);
    pause(1.0);

    timeToGoToPoseInMs = 300.0;
    for j = 1:size(poses,2)
        for i = 1:(timeToGoToPoseInMs/20.0)
            if delta
                setAngles( currentPose + (i * ( poses(:,j) / (timeToGoToPoseInMs/20.0) ) ));
            else
                setAngles( currentPose + i * ( (poses(:,j) - currentPose) / (timeToGoToPoseInMs/20.0) ) );
            end
            pause(0.02);
        end
        currentPose = currentPose+poses(:,j);
    end
    
    % A short pause to give the pose a chance to fall over
    pause(2.0);
    
    % simxGetJointMatrix
    % pointer to 12 simFloat values (the last row of the 4x4 matrix (0,0,0,1) is not needed)
    % The x-axis of the orientation component is (matrix[0],matrix[4],matrix[8])
    % The y-axis of the orientation component is (matrix[1],matrix[5],matrix[9])
    % The z-axis of the orientation component is (matrix[2],matrix[6],matrix[10])
    % The translation component is (matrix[3],matrix[7],matrix[11])
    [~,HeadPosition]=vrep_connection.vrep.simxGetObjectPosition(vrep_connection.clientID,vrep_connection.Head,vrep_connection.Floor,vrep_connection.vrep.simx_opmode_oneshot_wait);
    [~,LFootPosition]=vrep_connection.vrep.simxGetObjectPosition(vrep_connection.clientID,vrep_connection.LAnkleRoll,vrep_connection.Floor,vrep_connection.vrep.simx_opmode_oneshot_wait);
    [~,RFootPosition]=vrep_connection.vrep.simxGetObjectPosition(vrep_connection.clientID,vrep_connection.RAnkleRoll,vrep_connection.Floor,vrep_connection.vrep.simx_opmode_oneshot_wait);
    setAngles(vrep_connection.startPose);
    
    f = 6+sum([-5;-5;10].*[HeadPosition(3);LFootPosition(3);RFootPosition(3)]);
    if f<vrep_connection.fitness
        vrep_connection.fitness=f;
        vrep_connection.elitist = poses;
    end
    
    vrep_connection.vrep.simxStopSimulation(vrep_connection.clientID,vrep_connection.vrep.simx_opmode_oneshot_wait);
end





