function [Actions, Basisfunctions, reward, Z] = createSampleVREP(W,M,tau)
%CREATESAMPLE Summary of this function goes here
%   These parameters have to be the same as the parameters in the
%   evaluation-script
%   TODO: set these paramater via function parameters
    Latent = 6;
    nmbrOfGroups = 3; %Die Anzahl der Gruppen (Beine,Arme,Kopf) ==> 5 (ARM;ARM;BEIN;BEIN;KOPF)
    DimPerGroup = [2 12 12]; % Head LArm LLeg RLeg RArm
    DoF = sum(DimPerGroup);
    Time = 25;

    % Create the time-Basis functions
    means = (-3):3:(Time+3);
    BasisDim = length(means);
    variance = 3;
    featureFun = @(t) cell2mat(arrayfun(@(t_i) normpdf(t_i,means,variance)',t,'UniformOutput',0));
    Basisfunctions = featureFun(1:Time);
    Basisfunctions = Basisfunctions ./ repmat(sum(Basisfunctions),BasisDim,1);
    Z = randn(Latent,BasisDim);
    
    Actions = zeros(DoF,Time);
    
    
    for t=1:Time
        for m=1:nmbrOfGroups
            startDim = 1 + sum(DimPerGroup(1:(m-1)));
            Actions(startDim:(startDim + DimPerGroup(m) - 1),t) = ...
                W{m} * Z * Basisfunctions(:,t) + ...
                M{m} * Basisfunctions(:,t) + ...
                normrnd(0,inv(tau{m})+2, DimPerGroup(m), BasisDim) * Basisfunctions(:,t);
        end
    end
    
    reward = zeros(1,Time);
    
   % You personal function goes here
   % reward = func(Actions)
   % reward has to have the size of zeros(1,Time), if it is scalar just uncomment
   %reward = 
   % HIER DEN REWARD BERECHNEN ENTWEDER F�R JEDEN ZEITSCHRITT (25) ACTIONS SIND DIE DATEN
   %calcEndeffektorVREP
   
   %Actions/1000.0
   buffer = [Actions(1:8,:);Actions(15:26,:);Actions(9:14,:)];
   reward = calcEndeffektorVREP(buffer/500.0,true); %/1000 um Wertebereich sinnvoll f�r radian winkel des Nao zu machen
   fprintf('Inverse Reward: %f\n',reward);
   reward = ones(1,Time) * reward;

    %transform reward such that r in [0,1]
    reward2 = exp(-reward);
    
    %For the moment there is only an episode based reward
    reward = ones(size(reward2)) * sum(reward2);
    
    Z = Z*Basisfunctions;
end

