%close all;
%clear all;
%clear all;
if exist('vrep_connection','var')~= 1
    initVREP('127.0.0.1',19999);
end
global vrep_connection;
global recording;

ExperimentNmbr = 1;
rng(42+ExperimentNmbr^2 - ExperimentNmbr);

bestSize = 15;  %Wieviele der besten Samples werden genommen um die Parameter zu berechnen
newSamples = 30; %Wieviele werden neu generiert pro Iteration
sampleSize = 30; %Wieviele Samples pro Iteration zur Verf�gung stehen
nmbrGroups = 3; %Die Anzahl der Gruppen (Beine,Arme,Kopf) ==> 5 (ARM;ARM;BEIN;BEIN;KOPF)
DimPerGroup = [2 12 12]; % Head (LArm LLeg) (RLeg RArm)
latentDim = 6;                                      %Die Anzahl der St�tzpunkte in der Bewegung ==> 6 ist ok 
Time = 25; %Das ist die ANZAHL der St�tzpunkte
featureDim = length((-3):3:(Time+3));
createSamplesFunc = @createSampleVREP;
evaluateFunc = @evaluationFunctionVREP;

% Here you may set the initial mean polic
% initialM has to be a cell array
% In this example, the first cell corresponds to the 
% first group with four dimensions like gibven in DimPerGroup
% The second one will have two dimensions etc
% In these concrete example, the first and seventh row of 
% the M-matrix will be  initialized to 30 and 150.
% If there is onyl on group, initialM consists only of
% one cell and you would use initialM{1}(1,:) = 30
% and initialM{1}(7,:) = 150 to get the same matrix/effect
initialM = cell(nmbrGroups,1);
for m=1:nmbrGroups
    initialM{m} = zeros(DimPerGroup(m),featureDim);
end
%initialM{1}(1,:) = 30;
%initialM{3}(1,:) = 150;

maxNumberOfIterations = 1000;
maxNumberOfInnerIterations = 20;
sigma2_M = 100;
antiConvergenceFactor = 1.5;
tauA = 1000;
tauB = 1000;
alphaA = 1;
alphaB = 1;
initialTau = inv(10^1.5);
initialAlpha = 1; 

[M,W,tau,alpha,rewardOverTime ] = ...
GrouPS(bestSize,newSamples,sampleSize, nmbrGroups, DimPerGroup, latentDim, featureDim, Time, createSamplesFunc, evaluateFunc, initialM, maxNumberOfIterations, maxNumberOfInnerIterations, sigma2_M, antiConvergenceFactor, tauA, tauB, alphaA, alphaB, initialTau, initialAlpha);

save(['One_' num2str(ExperimentNmbr) '.mat'],'M','W','tau','alpha','rewardOverTime');
