function [Actions, Basisfunctions, reward, Z] = evaluationFunctionVREP(W,M,tau)
%CREATESAMPLE Summary of this function goes here
%   Detailed explanation goes here
    
    Latent = 6;
    nmbrOfGroups = 3; %Die Anzahl der Gruppen (Beine,Arme,Kopf) ==> 5 (ARM;ARM;BEIN;BEIN;KOPF)
    DimPerGroup = [2 12 12]; % Head LArm LLeg RLeg RArm
    DoF = sum(DimPerGroup);
    Time = 25;
    
    
    %Create time-based basius functions
    means = (-3):3:(Time+3);
    BasisDim = length(means);
    variance = 3;
    featureFun = @(t) cell2mat(arrayfun(@(t_i) normpdf(t_i,means,variance)',t,'UniformOutput',0));
    Basisfunctions = featureFun(1:Time);
    Basisfunctions = Basisfunctions ./ repmat(sum(Basisfunctions),BasisDim,1);

    %create latent variables
    Z = randn(Latent,BasisDim);
    
    %reserves space for actions
    Actions = zeros(DoF,Time);
    hitRange = 0;
    
    %create actions
    % For the evaluation we are only interested in the mean
    % policy, for testing you may include (uncomment) the probabilistic components
    for t=1:Time
        for m=1:nmbrOfGroups
            startDim = 1 + sum(DimPerGroup(1:(m-1)));
            Actions(startDim:(startDim + DimPerGroup(m) - 1),t) = ...
                ...W{m} * Z * Basisfunctions(:,t) + ...
                M{m} * Basisfunctions(:,t)....
                ...+ normrnd(0,inv(sqrt(tau{m})), DimPerGroup(m), BasisDim) * Basisfunctions(:,t)...
                ;
        end
    end
    
    reward = 0;
    %TO DO HIER COPY PASTE
    buffer = [Actions(1:8,:);Actions(15:26,:);Actions(9:14,:)];
    reward = calcEndeffektorVREP(buffer/500.0,true); %/1000 um Wertebereich sinnvoll f�r radian winkel des Nao zu machen
    fprintf('Inverse Reward: %f\n',reward);
    global recording;
    r = cell(1,4);
    r{1,1} = M;
    r{1,2} = W;
    r{1,3} = tau;
    r{1,4} = reward;
    recording = [recording; r];

    %Hier function-Aufruf mit den generierten Actions und 
    % Rückgabe eines scalaren rewards für den Plot
    % Falls kein scalarer Reward dann Rückgabe der sum

    %reward = sum(reward);
end

