function [Actions, Basisfunctions, reward, Z] = createSampleAndDrawTwoArms(W,M,tau, Latent, DimPerGroup,Time, draw)
%createSampleAndDrawTwoArms Evaluation function of the two arms simulation
%   Detailed explanation goes here
    DoF = sum(DimPerGroup);%12;

    if DoF ~= 12
        warning('Experiment is designed for 12 DoF. The number of DoF is not equal 12. Possible error!');
    end
    if DoF < 7
        error('Experiment requires at least 7 DoF.');
    end
    
    nmbrOfGroups = length(DimPerGroup);%4;
    %DimPerGroup = [ 4 2 4 2];

    %Time = 50;
    %Time = 25;
    
    %x = cos((1:Time) *( 2* pi /Time))*0.5 + 5;
    %y = sin((1:Time) *( 2* pi /Time));
    %x = cos((1:Time).*0.15) + 6 - 2.5;
    %y = sin((1:Time).*0.15).*1.5 + 2;
    %x = cos((1:Time) *( 2* pi /Time))*1.5 + 3;
    %y = sin((1:Time) *( 2* pi /Time))+2;
    x = 4 - (1:Time)./Time * 4;
    y = 4 * ones(1,Time);
    x2 = -x;
    
    %for t=1:Time
    %    drawRobo([0 0 0 0 0 0], [x(t) y(t) 0]);
    %    pause(0.2);
    %end
    means = (-3):3:(Time+3);
    BasisDim = length(means);
    variance = 3;
    featureFun = @(t) cell2mat(arrayfun(@(t_i) normpdf(t_i,means,variance)',t,'UniformOutput',0));
    Basisfunctions = featureFun(1:Time);
    Basisfunctions = Basisfunctions ./ repmat(sum(Basisfunctions),BasisDim,1);
    Z = randn(Latent,BasisDim);
    
    Actions = zeros(DoF,Time);
    hitRange = 0;
    
    for t=1:Time
        for m=1:nmbrOfGroups
            startDim = 1 + sum(DimPerGroup(1:(m-1)));
            Actions(startDim:(startDim + DimPerGroup(m) - 1),t) = ...
                ...W{m} * Z * Basisfunctions(:,t) + ...
                M{m} * Basisfunctions(:,t)....
                ...+ normrnd(0,inv(tau{m}), DimPerGroup(m), BasisDim) * Basisfunctions(:,t)...
                ;
        end
        for i=1:DoF
            if -180 > Actions(i,t) || 180 < Actions(i,t)
                hitRange = 1;
            end
            %Actions(i,t) = max(-180, min( 180, Actions(i,t)));
        end
    end
    
    reward = 0;
    CurrentAngle = zeros(DoF,1);
    for t=1:Time
        CurrentAngle = Actions(:,t);...+ CurrentAngle;
        position = calcEndeffektor(CurrentAngle(1:6)');
        position2 = calcEndeffektor(CurrentAngle(7:end)');
        %position = calcEndeffektor(Actions(:,t)');
        reward = reward + norm([x(t) y(t)] - position(1:2)',2);
        reward = reward + norm([x2(t) y(t)] - position2(1:2)',2);
        if draw
            drawRoboTwoArms(CurrentAngle(1:6)',CurrentAngle(7:end)', [x(t) y(t) 0], [x2(t) y(t) 0]);
            drawnow
            %pause(0.001);
        end
    end
     
   % if hitRange
   %     reward = 2000;
   % end
   % reward = exp(-(reward).^1.5/25);
    %fprintf('\tReward %f\n', reward);
    Z = repmat(Z,1,Time);
    %Actions = randn(10,20);
    %Basisfunctions = eye(20,20);
    %reward = randn;
    %Z = randn(3,20);
end

