% Set a unique experiment number
ExperimentNmbr = 1;
% Initialize the random number generator
rng(42+ExperimentNmbr^2 - ExperimentNmbr);

% Set the parameters
bestSize = 15;
newSamples = 30;
sampleSize = 30;
nmbrGroups = 4;
DimPerGroup = [4 2 4 2];
latentDim = 6;
featureDim = 11;
Time = 25;
createSamplesFunc = @(W,M,tau) createSampleStepsTwoArms(W,M,tau,latentDim,DimPerGroup,Time,1);
evaluateFunc = @(W,M,tau) createSampleAndDrawTwoArms(W,M,tau,latentDim,DimPerGroup,Time,1);

%initialize M
initialM = cell(nmbrGroups,1);
for m=1:nmbrGroups
    initialM{m} = zeros(DimPerGroup(m),featureDim);
end
initialM{1}(1,:) = 30;
initialM{3}(1,:) = 150;

maxNumberOfIterations = 1000;
maxNumberOfInnerIterations = 20;
sigma2_M = 100;
antiConvergenceFactor = 1.5;
tauA = 1000;
tauB = 1000;
alphaA = 1;
alphaB = 1;
initialTau = inv(10^1.5);
initialAlpha = 1; 

% The main algorithm
[M,W,tau,alpha,rewardOverTime ] = ...
GrouPS(bestSize,newSamples,sampleSize, nmbrGroups, DimPerGroup, latentDim, featureDim, Time, createSamplesFunc, evaluateFunc, initialM, maxNumberOfIterations, maxNumberOfInnerIterations, sigma2_M, antiConvergenceFactor, tauA, tauB, alphaA, alphaB, initialTau, initialAlpha);

% Save a file
save(['One_' num2str(ExperimentNmbr) '.mat'],'M','W','tau','alpha','rewardOverTime');
